//Phantasma
//Version 0.03
#include "stdafx.h"
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <string>
#include "windows.h"
#include <time.h>
#include "graphics.h"
#include <stdlib.h>
using namespace std;
void pause(int option)
{
	char pauseVariable;
	if(option==0)
		system("PAUSE");
	if(option==1)
		system("PAUSE>NUL");
	if(option==2){
		cout<<"Press any key and enter to continue..."<<endl;
		cin>>pauseVariable;
	}
	return;
}

void brk(int lines)
{
	for(int i=0;i<lines;i++)
	{
		cout<<endl;
	}
}
void cls()
{
	system("cls");
}
int rng(int sides)
{
	int out=rand() % sides + 1;
	return out;
}
void disp(const char text[32],int length,short delay)
{
	for(int i=0;i<length;i++)
	{
		cout<<text[i];
		Sleep(delay);
	}
	cout<<endl;
}

void sDisp(const char text[32],int length,short delay,int t1,int t2, int opt){
	int sDelay;
	sDelay=delay-10;
	for(int i=0;i<length;i++)
	{
		cout<<text[i];
		Beep(t1,5);
		Beep(t2,5);
		Sleep(sDelay);
	}
	if(opt==0)
		cout<<endl;
	if(opt==1)
		return;
	return;
}
void screenFlash(){
	//sequence F 7 8 7 F
	//bg,tx
	int dly=25;
	system("COLOR F0");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR 80");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR F0");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR 80");
	Sleep(dly);
	system("COLOR 08");
	Sleep(dly);
	system("COLOR 07");
	Sleep(dly);
	system("COLOR 0F");
	return;
}
void playSound(int id){
	if(id==0){
		//menu select sound
		Beep(440,25);
		return;
	}
	if(id==1){
		//put another sound here
		return;
	}
	cout<<"No sound with the selected ID exists."<<endl;
	brk(1);
	return;
}
void showGraphic(int id){
	if(id==0){
		//title screen
		return;
	}
	if(id==1){
		//put more graphics here
		return;
	}
	cout<<"No graphic with the selected ID exists."<<endl;
	brk(1);
	return;
}
void loadGame(){
	cls();
	cout<<"Incomplete function."<<endl;
	pause(0);
	return;
}
void setup(){
	cls();
	cout<<"Color schemes:"<<endl;
	brk(1);
	pause(0);
	return;
}
void readMe(char version[4],char buildDate[10]){
	cls();
	cout<<"P H A N T A S M A"<<endl;
	cout<<" v"<<version<<" Build "<<buildDate<<endl;
	cout<<"Copyright 2017 AiO Softworks"<<endl;
	brk(1);
	cout<<"Credits go to:"<<endl;
	cout<<" Programming	- FAMICOMASTER"<<endl;
	cout<<" Graphics	- SkipperDMudkipz"<<endl;
	cout<<" Maps		- Hungrydurp"<<endl;
	cout<<" Story		- TheArkAngel"<<endl;
	cout<<" Sounds		- Churro"<<endl;
	brk(1);
	pause(0);
	return;
}

int quizGender(){
	char gender;
	cls();
	cout<<"First: Are you a male or a female?"<<endl;
	cout<<"Type M or F..."<<endl<<"]";
	cin>>gender;
	playSound(0);
	switch(gender){
		case 'm':
			return 0;
		case 'M':
			return 0;
		case 'f':
			return 1;
		case 'F':
			return 1;
		default:
			return 2;
	}
}

int quizRace(){
	cls();
	char race;
	cout<<"Choose your race from the list below:"<<endl;
	Sleep(10);
	cout<<" 1. Human"<<endl;
	Sleep(5);
	cout<<" 2. Elven"<<endl;
	Sleep(5);
	cout<<" 3. Dwarven"<<endl;
	Sleep(5);
	cout<<" 4. Goblin"<<endl;
	Sleep(1);
	cout<<"]";
	cin>>race;
	playSound(0);
	switch(race){
		case '1':
			return 0;
		case '2':
			return 1;
		case '3':
			return 2;
		case '4':
			return 3;
		default:
			return 4;
	}
}
int quizClass(){
	cls();
	char pclass;
	cout<<"Choose your class from the list below:"<<endl;
	Sleep(10);
	cout<<" 1. Sorcerer"<<endl;
	Sleep(5);
	cout<<" 2. Warrior"<<endl;
	Sleep(5);
	cout<<" 3. Cleric"<<endl;
	Sleep(5);
	cout<<" 4. Archer"<<endl;
	Sleep(5);
	cout<<" 5. Defender"<<endl;
	Sleep(5);
	cout<<" 6. Rider"<<endl;
	Sleep(1);
	cout<<"]";
	cin>>pclass;
	playSound(0);
	switch(pclass){
		case '0':
			return 6;
		case '1':
			return 0;
		case '2':
			return 1;
		case '3':
			return 2;
		case '4':
			return 3;
		case '5':
			return 4;
		case '6':
			return 5;
		default:
			return 7;
	}
	return 0;
}
void stats(int pstats[24],char name[16]){
	//itoa(value,string,base);
	cls();
	char outa[4];
	char outb[4];
	cout<<"Player "<<name<<"'s stats:"<<endl;
	brk(1);
	itoa(pstats[0],outa,10);
	itoa(pstats[2],outb,10);
	cout<<"  HP: "<<outa<<" / "<<outb<<endl;
	itoa(pstats[1],outa,10);
	itoa(pstats[3],outb,10);
	cout<<"  MP: "<<outa<<" / "<<outb<<endl;

	brk(1);
	pause(0);
	return;
}
void gameMenu(int pstats[24],char name[16]){
	cls();
	char choice;
	disp("P H A N T A S M A",18,15);
	Sleep(15);
	cout<<"Game menu"<<endl<<"Pick an option and press enter."<<endl;
	Sleep(15);
	cout<<" 1. Look around"<<endl;
	Sleep(5);
	cout<<"   N"<<endl<<endl<<" W + E"<<endl<<endl<<"   S"<<endl;
	Sleep(5);
	cout<<" 2. Check map"<<endl;
	Sleep(5);
	cout<<" 3. Your stats"<<endl;
	Sleep(5);
	cout<<" 4. Party stats"<<endl;
	Sleep(5);
	cout<<" 5. Inventory"<<endl;
	Sleep(5);
	cout<<" 6. Quests"<<endl;
	Sleep(5);
	cout<<" 7. Options"<<endl;
	Sleep(5);
	cout<<" 8. Save"<<endl;
	Sleep(5);
	cout<<" 9. Exit"<<endl;
	Sleep(5);
	cout<<"]";
	cin>>choice;
	playSound(0);
	switch(choice){
		case '0':
			return;
		case '1':
			//look(x,y);
			break;
		case '2':
			//map(x,y);
			break;
		case '3':
			stats(pstats,name);
			break;
		case '4':
			//partyMenu();
			break;
		case '5':
			//inventory();
			break;
		case '6':
			//quests();
			break;
		case '7':
			setup();
			break;
		case '8':
			//save();
			break;
		case '9':
			exit(0);
	}
	return;
}
void storyTell(int pstats[24], char name[16]){
	cls();
	int rval;
	cout<<"Story goes here later..."<<endl;
	cout<<"Press any key to view stats (debug)..."<<endl;
	pause(1);
	cout<<pstats<<endl;
	cout<<name<<endl;
	pause(0);
	while(true){
		gameMenu(pstats,name);
	}
	return;
}
void createCharacter(int gender,int race,int pclass,char name[16]){
	cls();
	cout<<"Now creating your character."<<endl;
	cout<<"Please wait, this could take some time..."<<endl;
	int pstats[24];
	int atk,str,def,spd,hp,mp,bhp,bmp,xp,next,lvl,x,y,wid,qid;
	x=0;
	y=0;
	wid=0;
	qid=0;
	if(race==0){
		//human
		bhp=6;
		bmp=2;
		atk=5;
		def=3;
		str=4;
		spd=5;
	}
	if(race==1){
		//dwarf
		bhp=6;
		bmp=4;
		atk=3;
		def=6;
		str=6;
		spd=2;
	}
	if(race==2){
		//elf
		bhp=3;
		bmp=8;
		atk=2;
		def=2;
		str=3;
		spd=8;
	}
	if(race==3){
		//goblin
		bhp=5;
		bmp=3;
		atk=8;
		def=6;
		str=3;
		spd=2;
	}
	if(pclass==0){
		//sorcerer
		bhp=bhp*0.75;
		bmp=bmp*2;
		atk=atk*0.5;
		def=def*0.75;
		str=str*0.25;
		spd=spd*0.75;
	}
	if(pclass==1){
		//warrior
		bhp=bhp*2;
		bmp=bmp*0;
		atk=atk*2;
		def=def*1.25;
		str=str*1.25;
		spd=spd*0.75;
	}
	if(pclass==2){
		//cleric
		bhp=bhp*0.5;
		bmp=bmp*1.5;
		atk=atk*0.25;
		def=def*0.25;
		str=str*0.25;
		spd=spd*1.25;
	}
	if(pclass==3){
		//archer
		bhp=bhp*0.5;
		bmp=bmp*0.25;
		atk=atk*1.25;
		def=def*0.25;
		str=str*0;
		spd=spd*2;
	}
	if(pclass==4){
		//defender
		bhp=bhp*2;
		bmp=bmp*0;
		atk=atk*0.5;
		def=def*2;
		str=str*2;
		spd=spd*0.25;
	}
	if(pclass==5){
		//rider
		bhp=bhp*1.25;
		bmp=bmp*0;
		atk=atk*0.75;
		def=def*0.75;
		str=str*1.25;
		spd=spd*1.75;
	}
	if(pclass==6){
		//god
		bhp=20;
		bmp=20;
		atk=20;
		def=20;
		str=20;
		spd=20;
	}
	hp=bhp;
	mp=bmp;
	xp=0;
	next=25;
	lvl=1;
	//actually define player stats array
	//see readme for ID list
	pstats[0]=hp;
	pstats[1]=mp;
	pstats[2]=bhp;
	pstats[3]=bmp;
	pstats[4]=atk;
	pstats[5]=def;
	pstats[6]=str;
	pstats[7]=spd;
	pstats[8]=xp;
	pstats[9]=next;
	pstats[10]=lvl;
	pstats[11]=gender;
	pstats[12]=race;
	pstats[13]=pclass;
	pstats[14]=x;
	pstats[15]=y;
	pstats[16]=wid;
	pstats[17]=qid;
	storyTell(pstats,name);
	return;
}
void newGame(){
	int gender;
	int race;
	int pclass;
	char name[16];
	cls();
	while(true){
		gender=quizGender();
		if(gender==2)
			gender=quizGender();
		else
			break;
	}
	brk(1);
	while(true){
		race=quizRace();
		if(race==4)
			race=quizRace();
		else
			break;
	}
	brk(1);
	while(true){
		pclass=quizClass();
		if(pclass==7)
			pclass=quizClass();
		else
			break;
	}
	brk(1);
	cout<<"Finally, the most difficult question..."<<endl;
	cout<<"What shall your name be?"<<endl<<"]";
	cin>>name;
	cls();
	cout<<"Okay, "<<name<<", are you ready to start your journey?"<<endl;
	Sleep(500);
	disp(". . .",6,500);
	Sleep(500);
	sDisp("Well... ",8,125,0,0,1);
	Sleep(250);
	sDisp("TOO BAD!",8,250,500,250,0);
	Sleep(500);
	screenFlash();
	createCharacter(gender,race,pclass,name);
	return;
}
int title()
{
	char a;
	char version[8]="0.03";
	char buildDate[16]="04.21.2017";
	cls();
	disp("P H A N T A S M A",18,50);
	screenFlash();
	cout<<" v"<<version<<" Build "<<buildDate<<endl;
	cout<<"Copyright 2017 AiO Softworks"<<endl;
	brk(1);
	cout<<"Press a key and enter to play!"<<endl;
	cout<<" 1. New Game"<<endl;
	cout<<" 2. Load Game"<<endl;
	cout<<" 3. Colors"<<endl;
	cout<<" 4. Readme"<<endl;
	cout<<" 5. Exit"<<endl;
	cout<<"]";
	cin>>a;
	playSound(0);
	switch(a){
		case '0':
			return 2;
		case '1':
			newGame();
			break;
		case '2':
			loadGame();
			break;
		case '3':
			setup();
			break;
		case '4':
			readMe(version,buildDate);
			break;
		case '5':
			return 1;
		case '6':
			return 3;
		case '7':
			return 4;
		default:
			return 0;
	}
}

int main(){
	//error handler
	int returnValue;
	while(true){
		returnValue=title();
		if(returnValue==0){
			//Reset pointer
		}
		if(returnValue==1)
			break;
		if(returnValue==2){
			cls();
			cout<<"Tried to enter debug mode"<<endl;
			pause(0);
			break;
		}
		if(returnValue==3){
			cls();
			system("COLOR C0");
			cout<<"An error occurred!"<<endl;
			brk(1);
			cout<<"Press any key to exit the program..."<<endl;
			pause(1);
			break;
		}
	}
	return 0;
}